import Vue from 'vue';
import ScreenHandle from '@/directives/screen-handle';

Vue.config.productionTip = false;

/* eslint-disable no-new */
new Vue({
    el: '#app',
    directives: {
        screenHandle: ScreenHandle
    },
    components: {
        app: { template: '<div id="main"><slot></slot></div>' }
    },
    data: {
        name: '...',
        points: [],
        scale: 1,
        rotate: 0
    },
    methods: {
        onStart (evt, info) {
            this.name = '...';
            this.points = [];
            this.points = JSON.parse(JSON.stringify(info.points));
            this.scale = 1;
            this.rotate = 0;
        },
        onEnd (evt, info) {
            console.log(info);
        },
        onChange (evt, info) {
        },
        onHandle (evt, info) {
            this.name = info.name;
            this.points = JSON.parse(JSON.stringify(info.points));
        },
        onMoving (evt, info) {
            this.points = JSON.parse(JSON.stringify(info.points));
        },
        onPinch (evt, info) {
            this.scale = info.scale;
        },
        onPinchOpen (evt, info) {

        },
        onPinchClose (evt, info) {

        },
        onRotate (evt, info) {
            this.rotate = info.rotate;
        }
    },
    computed: {
    },
    mounted () {
        require('./index.less');
        // console.log(ScreenHandle);
    }
});
